/* global angular */

(function () {

	var app = angular.module('eventosContactApp');

	app.controller("activityFeedController", function ($scope, $rootScope, $state, dataService, $localStorage) {
		console.log("activityFeedController loaded");
		
		var modalNotification = new ModalNotification();
		$scope.$localStorage = $localStorage;
		$scope.dataService = dataService;
		
		$scope.itemsToShow = 15;
		$scope.loadingFeed = true;
		
		if(!$scope.$localStorage.selectedEvent){
			$state.go('app.home');
		}

		function initData(){
			if(typeof dataService.activityFeed !== 'undefined' && typeof dataService.persons !== 'undefined'){
				if(typeof $scope.activityFeed !== 'undefined'){ // Is refresh
					$.notify('Activity feed refreshed.');
				}
				$scope.activityFeed = angular.copy(dataService.activityFeed);
				for(var i = 0; i < $scope.activityFeed.length; i++){ // Fetch persons to allow using search on them.
					$scope.activityFeed[i].person = dataService.getByID('persons', 'personID', $scope.activityFeed[i].personID);
				}
				$scope.loadingFeed = false;
			}
		}
		dataService.getPersons();
		dataService.getActivityFeed();
		initData();
		$scope.$on('activityFeedLoaded', initData);
		
		function loadMore(){
			if(typeof $scope.activityFeed === "undefined"){
				return;
			}
			if($scope.activityFeed.length > $scope.itemsToShow){
				$scope.itemsToShow += 5;
				$scope.$digest();
			}
		}
		
		$scope.searchChanged = function(){
			if(typeof $scope.search === 'string'){
				$scope.itemsToShow = 15;
			}
		};
		
		$scope.refreshFeed = function(){
			$scope.loadingFeed = true;
			dataService.getActivityFeed();
		};
		
		var $activityFeed;
		
		function scrolled(e){
			if(typeof $activityFeed === 'undefined'){
				$activityFeed = $('#activity-feed-page');
			}
			var bottomOfPage = $activityFeed.position().top + $activityFeed.outerHeight(true);
			if(2 * window.innerHeight + window.pageYOffset > bottomOfPage){
				loadMore();
			}
		}
		
		window.addEventListener('scroll', scrolled);
		
		$scope.$on('$destroy', function () {
			window.removeEventListener('scroll', scrolled, false);
		});
		
	});
})();
