/* global angular */

(function () {

	var app = angular.module('eventosContactApp');

	app.controller("selectEventController", function ($scope, $rootScope, $state, $translate, dataService, $localStorage, $timeout) {
		console.log("selectEventController loaded");

		$scope.$localStorage = $localStorage;

		if (typeof dataService.events !== 'undefined') {
			$scope.events = dataService.events;
		}

		dataService.getEvents();

		$scope.$on('eventsLoaded', function () {
			$scope.events = dataService.events;
		});

		$scope.selectEvent = function (event) {
			if ($scope.$localStorage.selectedEvent !== null && typeof $scope.$localStorage.selectedEvent.eventID !== 'undefined' && $scope.$localStorage.selectedEvent.eventID !== event.eventID) {
				$scope.$localStorage.selectedScanPoint = null;
				dataService.clearData('scanPoints');
				dataService.clearData('eventBanner');
			}
			$scope.$localStorage.selectedEvent = event;
			$scope.$localStorage.scanPointSearch = ''; // Clear search
			$rootScope.pageTitle = event.name;
			dataService.getScanPoints();

			$timeout(function () {
				$state.go('app.home');
			});
		};
	});
})();