/* global angular */

(function () {

	var app = angular.module('eventosContactApp');

	// Contains app data
	app.service("metaService", ["$http", "$rootScope",
		function ($http, $rootScope) {

			var server = $rootScope.apiUrl;

			var that = this;
			var dataLoading = {
				persons: false,
			};
			
			this.getPersonsMeta = function(force){
				if (!dataLoading.persons || force) {
					dataLoading.persons = true;
					$http.get(server + 'persons/meta').
							then(function (response) {
								that.personsMeta = response.data.data.meta;
								dataLoading.persons = false;
								$rootScope.$broadcast('personsMetaLoaded');
							}, function (e) {
								dataLoading.persons = false;
								console.log("Error fetching persons meta.", e);
							});
				}
			};

		}]);
})();
